## snapd 2.71+ubuntu22.04

=== data/Makefile ===
all install clean:
	$(MAKE) -C systemd $@
	$(MAKE) -C systemd-user $@
	$(MAKE) -C systemd-env $@
	$(MAKE) -C systemd-tmpfiles $@
	$(MAKE) -C dbus $@
	$(MAKE) -C env $@
	$(MAKE) -C desktop $@
	$(MAKE) -C polkit $@

check:
	$(MAKE) -C systemd $@

=== tests/regression/lp-1812973/Makefile ===
name = lp-1812973

CFLAGS = -Wall -Werror
# build the test binary statically as it will be running inside the snap mount
# namespace that may use a base with an older version of glibc
LDFLAGS = -static

.PHONY: all
all: $(name)

.PHONY: clean
clean:
	rm -f $(name)

DESTDIR ?=

.PHONY: install
install: $(name)
	install -m 755 -d $(DESTDIR)/usr/bin/
	install -m 755 $(name) $(DESTDIR)/usr/bin/

.PHONY: fmt
fmt: $(name).c
	# NOTE: clang-format is using project-wide .clang-format file.
	clang-format -i $^

=== cmd/snap-update-ns/testdata/opt/Makefile ===
# This makefiles uses grouped-target feature and relies on it for correctness.
ifeq (,$(findstring grouped-target,$(.FEATURES)))
$(error You need make with the grouped-taget feature to build this dataset)
endif

fstab_files = \
	      1-initially-connected.current.fstab \
	      1-initially-connected.desired.fstab \
	      2-after-disconnect.desired.fstab \
	      2-after-disconnect.current.fstab \
	      3-after-reconnect.desired.fstab \
	      3-after-reconnect.current.fstab \
	      4-initially-disconnected-then-connected.before.current.fstab \
	      4-initially-disconnected-then-connected.desired.fstab \
	      4-initially-disconnected-then-connected.current.fstab \
	      5-initially-connected-then-content-refreshed.before.current.fstab \
	      5-initially-connected-then-content-refreshed.desired.fstab \
	      5-initially-connected-then-content-refreshed.current.fstab \
	      6-initially-connected-then-app-refreshed.before.current.fstab \
	      6-initially-connected-then-app-refreshed.desired.fstab \
	      6-initially-connected-then-app-refreshed.current.fstab

# None of the fstab files can be built in parallel as the depend on global system state.
.NOTPARALLEL: $(fstab_files)
.PHONY: all
all: $(fstab_files)

.PHONY:
clean:
	rm -f $(fstab_files)
	rm -f *.snap
	rm -f *.mountinfo
	rm -f *.find

$(addprefix 1-initially-connected,.desired.fstab .current.fstab .mountinfo) &: PREFIX=1-initially-connected
$(addprefix 1-initially-connected,.desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /opt >$(PREFIX).opt.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content

$(addprefix 2-after-disconnect,.desired.fstab .current.fstab .mountinfo) &: PREFIX=2-after-disconnect
$(addprefix 2-after-disconnect,.desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	sudo snap disconnect test-snapd-layout:content test-snapd-content:content
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /opt >$(PREFIX).opt.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content

$(addprefix 3-after-reconnect,.desired.fstab .current.fstab .mountinfo) &: PREFIX=3-after-reconnect
$(addprefix 3-after-reconnect,.desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	sudo snap disconnect test-snapd-layout:content test-snapd-content:content
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /opt >$(PREFIX).opt.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content

$(addprefix 4-initially-disconnected-then-connected,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: PREFIX=4-initially-disconnected-then-connected
$(addprefix 4-initially-disconnected-then-connected,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 2,$^)
	snap connections test-snapd-layout | grep -xF 'content    test-snapd-layout:content  -     -'
	snap run test-snapd-layout.sh -c true
	# This file is used by unit tests model the changes needed after the refresh below.
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).before.current.fstab
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /opt >$(PREFIX).opt.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content

$(addprefix 5-initially-connected-then-content-refreshed,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: PREFIX=5-initially-connected-then-content-refreshed
$(addprefix 5-initially-connected-then-content-refreshed,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap test-snapd-content_b_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	# This file is used by unit tests model the changes needed after the refresh below.
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).before.current.fstab
	sudo snap install --dangerous $(word 3,$^) # Refresh the content.
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /snap/test-snapd-content/x1/ >$(PREFIX).content-x1.find
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /snap/test-snapd-content/x2/ >$(PREFIX).content-x2.find
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /opt >$(PREFIX).opt.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content

$(addprefix 6-initially-connected-then-app-refreshed,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: PREFIX=6-initially-connected-then-app-refreshed
$(addprefix 6-initially-connected-then-app-refreshed,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	# This file is used by unit tests model the changes needed after the refresh below.
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).before.current.fstab
	sudo snap install --dangerous $(word 1,$^) # Refresh the app.
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /opt >$(PREFIX).opt.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content

test-snapd-layout_a_all.snap: test-snapd-layout
	snap pack $<

test-snapd-content_a_all.snap: test-snapd-content-a
	snap pack $<

test-snapd-content_b_all.snap: test-snapd-content-b
	snap pack $<

=== tests/lib/snaps/store/test-snapd-base-bare/Makefile ===
#!/usr/bin/make -f

DIRS := dev etc home lib/modules media proc root \
	run/media run/netns \
	snap sys tmp \
	usr/bin usr/lib/snapd usr/src \
	var/lib/snapd var/log var/snap var/tmp

install:
	mkdir -p $(DIRS)

clean:
	rm -rf $(DIRS)

=== core-initrd/24.04/debian/changelog ===
ubuntu-core-initramfs (69+2.70+g138.873912a+24.04) noble; urgency=medium

  * Update to snapd version 2.70+g138.873912a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 03 Jul 2025 21:49:35 -0400

ubuntu-core-initramfs (69+2.70+g50.d4bfa73+24.04) noble; urgency=medium

  * Update to snapd version 2.70+g50.d4bfa73

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 12 Jun 2025 10:16:34 -0400

ubuntu-core-initramfs (69+2.69+g139.0b18e2d+24.04) noble; urgency=medium

  * Update to snapd version 2.69+g139.0b18e2d

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 21 May 2025 15:31:34 -0400

ubuntu-core-initramfs (69+2.69+g104.4871148+24.04) noble; urgency=medium

  * Update to snapd version 2.69+g104.4871148

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 30 Apr 2025 13:13:00 -0400

ubuntu-core-initramfs (69+2.68.2+g116.194fb1d+24.04) noble; urgency=medium

  * Update to snapd version 2.68.2+g116.194fb1d

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 07 Mar 2025 17:01:51 -0500

ubuntu-core-initramfs (69+2.68.2+24.04) noble; urgency=medium

  * Update to snapd version 2.68.2

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Mon, 03 Mar 2025 09:38:06 -0500

ubuntu-core-initramfs (69+2.68+g387.699b1b4+24.04) noble; urgency=medium

  * Update to snapd version 2.68+g387.699b1b4

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 20 Feb 2025 07:46:14 -0500

ubuntu-core-initramfs (69+2.67+git124.g98d9ab6+24.04) noble; urgency=medium

  * Update to snapd version 2.67+git124.g98d9ab6

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 08 Jan 2025 13:51:11 -0500

ubuntu-core-initramfs (68) noble; urgency=medium

  [ Valentin David ]
  * Fix path to /sbin/modprobe
  * Workaround wrong path to dmsetup
  * Workaround /usr/lib/modules path being prefixed with sysroot
  * Remove systemd-tpm2 services

  [ Alfonso Sanchez-Beato ]
  * HACKING.md: adapt to changes in mantic and forward
  * Make sure the initramfs can be cross-built
  * Include dbus files for org.freedesktop.systemd1
  * Create manifest with used packages

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Mon, 08 Apr 2024 20:36:26 +0100

ubuntu-core-initramfs (67) noble; urgency=medium

  * Bumping version for noble release

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 09 Feb 2024 08:57:32 +0000

ubuntu-core-initramfs (66) jammy; urgency=medium

  [ Dimitri John Ledkov ]
  * Enable riscv64 build

  [ Philip Meulengracht ]
  * github: fix the lxd-image workflow

  [ Alfonso Sanchez-Beato ]
  * tests: avoid interactions when using apt
  * bin/ubuntu-core-initramfs: fix ubuntu-core-initramfs crash
  * Update to systemd 249.11-0ubuntu3.6
  * Add GPU and input virtio modules
  * Include cryptsetup from FDE ICE PPA (no sources changed)
  * Include snapd 2.59 (no sources changed)

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 22 Mar 2023 13:30:31 +0000

ubuntu-core-initramfs (65) jammy; urgency=medium

  * Build from "main" branch to include fix:
   - "Wait 10 seconds before emergency reboot"

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 24 Jan 2023 17:39:17 +0100

ubuntu-core-initramfs (64) jammy; urgency=medium

  * No change rebuild to pick up snapd 2.58.1+22.04

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 24 Jan 2023 17:29:55 +0100

ubuntu-core-initramfs (63) jammy; urgency=medium

  * No change rebuild to pick up snapd 2.58~rc2+22.04

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 23 Nov 2022 10:42:40 +0000

ubuntu-core-initramfs (62) jammy; urgency=medium

  [ Valentin David ]
  * factory: add generator for kernel mount points on classic. This is
    a fix for a regression introduced in 61.

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 18 Nov 2022 18:49:04 +0000

ubuntu-core-initramfs (61) jammy; urgency=medium

  [ Dimitri John Ledkov ]
  * debian/rules: drop cloudimg-rootfs forked snap-bootstrap, as support
    for it is now merged into snapd.

  [ Valentin David ]
  * factory: move mount units into /etc/fstab, so rootfs systemd can track them.

  [ Alfonso Sanchez-Beato ]
  * factory,debian: include plymouth classic splash and use it if starting
    classic.

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 09 Nov 2022 11:18:04 +0000

ubuntu-core-initramfs (60) jammy; urgency=medium

  [ Valentin David ]
  * Break cycle with plymouth systemd-password
  * Remove populate-writable.service from basic.target

  [ Alfonso Sanchez-Beato ]
  * Include intel drm module in initramfs, for splash

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 29 Sep 2022 11:20:59 +0100

ubuntu-core-initramfs (59) jammy; urgency=medium

  * No change release to pick up snapd 2.57.3

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 15 Sep 2022 19:38:42 +0100

ubuntu-core-initramfs (58) jammy; urgency=medium

  [ Valentin David ]
  * Do not forward journal to console when quiet

  [ Alfonso Sanchez-Beato ]
  * Support for splash screen

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 08 Sep 2022 17:25:24 +0100

ubuntu-core-initramfs (57) jammy; urgency=medium

  * Fix cloudimg-rootfs feature in jammy.

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Mon, 15 Aug 2022 16:09:50 +0100

ubuntu-core-initramfs (56) jammy; urgency=medium

  [ Valentin David ]
  * Update systemd to 249.11-0ubuntu3
  * Fix recovery chooser trigger on NUC
  * Print warnings when modules are force loaded when they don't need to
  * Move modules that do not need force-loading to modules folder
  * debian/rules: Remove more unused systemd files
  * Mount UC mounts only when UC is detected

  [ Jian Hui Lee ]
  * add required drivers on Intel platform

  [ Alfonso Sanchez-Beato ]


=== core-initrd/25.04/debian/changelog ===
ubuntu-core-initramfs (71+2.70+g138.873912a+25.04) plucky; urgency=medium

  * Update to snapd version 2.70+g138.873912a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 03 Jul 2025 21:50:25 -0400

ubuntu-core-initramfs (71+2.70+g50.d4bfa73+25.04) plucky; urgency=medium

  * Update to snapd version 2.70+g50.d4bfa73

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 12 Jun 2025 10:17:25 -0400

ubuntu-core-initramfs (71+2.69+g139.0b18e2d+25.04) plucky; urgency=medium

  * Update to snapd version 2.69+g139.0b18e2d

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 21 May 2025 15:32:20 -0400

ubuntu-core-initramfs (71+2.69+g104.4871148+25.04) plucky; urgency=medium

  * Update to snapd version 2.69+g104.4871148

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 30 Apr 2025 13:14:10 -0400

ubuntu-core-initramfs (71+2.68.2+g116.194fb1d+25.04) plucky; urgency=medium

  * Update to snapd version 2.68.2+g116.194fb1d

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 07 Mar 2025 17:02:35 -0500

ubuntu-core-initramfs (71+2.68.2+25.04) plucky; urgency=medium

  * Update to snapd version 2.68.2

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Mon, 03 Mar 2025 09:38:49 -0500

ubuntu-core-initramfs (71+2.68+g387.699b1b4+24.10ubuntu1) plucky; urgency=medium

  * First plucky release

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 20 Feb 2025 07:55:44 -0500

ubuntu-core-initramfs (70+2.68+g387.699b1b4+24.10) oracular; urgency=medium

  * Update to snapd version 2.68+g387.699b1b4

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 20 Feb 2025 07:46:35 -0500

ubuntu-core-initramfs (70+2.67+git124.g98d9ab6+24.10) oracular; urgency=medium

  * Update to snapd version 2.67+git124.g98d9ab6

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 08 Jan 2025 13:52:06 -0500

ubuntu-core-initramfs (69) oracular; urgency=medium

  * Add systemd-cryptsetup, which is now a separate package, and libkmod2.
    that is dlopen'ed by systemd now.

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Mon, 07 Oct 2024 12:10:15 -0400

## snapd 2.71+ubuntu25.04

=== data/systemd/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SNAPD_ENVIRONMENT_FILE := /etc/environment
SNAP_MOUNT_DIR ?= /snap
BINDIR := /usr/bin
LIBEXECDIR := /usr/lib
SYSTEMDSYSTEMUNITDIR := /lib/systemd/system

# NOTE: the code in wrappers/core18.go assumes that all our service units's
# name start with the "snapd." prefix; units whose filename does not have this
# prefix will not be installed on the host!
SYSTEMD_UNITS_GENERATED := $(wildcard *.in)
# NOTE: sort removes duplicates so this gives us all the units, generated or otherwise
SYSTEMD_UNITS = $(sort $(SYSTEMD_UNITS_GENERATED:.in=) $(wildcard *.service) $(wildcard *.timer) $(wildcard *.socket) $(wildcard *.target))

.PHONY: all
all: $(SYSTEMD_UNITS)

.PHONY: check
check: snapd.run-from-snap snapd.core-fixup.sh
	if command -v shellcheck >/dev/null; then shellcheck $^; fi

.PHONY: install
install: $(SYSTEMD_UNITS)
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR)
	install -m 0644 -t $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR) $^
	install -d -m 0755 $(DESTDIR)/$(LIBEXECDIR)/snapd
	install -m 0755 -t $(DESTDIR)/$(LIBEXECDIR)/snapd snapd.core-fixup.sh
	install -m 0755 -t $(DESTDIR)/$(LIBEXECDIR)/snapd snapd.run-from-snap

.PHONY: clean
clean:
	rm -f $(SYSTEMD_UNITS_GENERATED:.in=)

%: %.in
	cat $< | \
		sed s:@libexecdir@:$(LIBEXECDIR):g | \
		sed s:@SNAPD_ENVIRONMENT_FILE@:$(SNAPD_ENVIRONMENT_FILE):g | \
		sed s:@bindir@:$(BINDIR):g | \
		sed s:@SNAP_MOUNT_DIR@:$(SNAP_MOUNT_DIR):g  | \
		cat > $@

=== cmd/snap-update-ns/testdata/usr-share-secureboot-potato/Makefile ===
# This makefiles uses grouped-target feature and relies on it for correctness.
ifeq (,$(findstring grouped-target,$(.FEATURES)))
$(error You need make with the grouped-taget feature to build this dataset)
endif

fstab_files = \
	      1-initially-connected.current.fstab \
	      1-initially-connected.desired.fstab \
	      2-after-disconnect.desired.fstab \
	      2-after-disconnect.current.fstab \
	      3-after-reconnect.desired.fstab \
	      3-after-reconnect.current.fstab \
	      4-initially-disconnected-then-connected.before.current.fstab \
	      4-initially-disconnected-then-connected.desired.fstab \
	      4-initially-disconnected-then-connected.current.fstab \
	      5-initially-connected-then-content-refreshed.before.current.fstab \
	      5-initially-connected-then-content-refreshed.desired.fstab \
	      5-initially-connected-then-content-refreshed.current.fstab \
	      6-initially-connected-then-app-refreshed.before.current.fstab \
	      6-initially-connected-then-app-refreshed.desired.fstab \
	      6-initially-connected-then-app-refreshed.current.fstab

# None of the fstab files can be built in parallel as the depend on global system state.
.NOTPARALLEL: $(fstab_files)
.PHONY: all
all: $(fstab_files)

.PHONY:
clean:
	rm -f $(fstab_files)
	rm -f *.snap
	rm -f *.mountinfo
	rm -f *.find

$(addprefix 1-initially-connected,.desired.fstab .current.fstab .mountinfo) &: PREFIX=1-initially-connected
$(addprefix 1-initially-connected,.desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /usr/share/secureboot >$(PREFIX).usr.share.secureboot.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-1.patch

$(addprefix 2-after-disconnect,.desired.fstab .current.fstab .mountinfo) &: PREFIX=2-after-disconnect
$(addprefix 2-after-disconnect,.desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	sudo snap disconnect test-snapd-layout:content test-snapd-content:content
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /usr/share/secureboot >$(PREFIX).usr.share.secureboot.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-2.patch

$(addprefix 3-after-reconnect,.desired.fstab .current.fstab .mountinfo) &: PREFIX=3-after-reconnect
$(addprefix 3-after-reconnect,.desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	sudo snap disconnect test-snapd-layout:content test-snapd-content:content
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /usr/share/secureboot >$(PREFIX).usr.share.secureboot.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-3.patch

$(addprefix 4-initially-disconnected-then-connected,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: PREFIX=4-initially-disconnected-then-connected
$(addprefix 4-initially-disconnected-then-connected,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	snap connections test-snapd-layout | grep -xF 'content    test-snapd-layout:content  -     -'
	snap run test-snapd-layout.sh -c true
	# This file is used by unit tests model the changes needed after the refresh below.
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).before.current.fstab
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /usr/share/secureboot >$(PREFIX).usr.share.secureboot.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-4.patch

$(addprefix 5-initially-connected-then-content-refreshed,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: PREFIX=5-initially-connected-then-content-refreshed
$(addprefix 5-initially-connected-then-content-refreshed,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap test-snapd-content_b_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	# This file is used by unit tests model the changes needed after the refresh below.
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).before.current.fstab
	sudo snap install --dangerous $(word 3,$^) # Refresh the content.
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /snap/test-snapd-content/x1/ >$(PREFIX).content-x1.find
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /snap/test-snapd-content/x2/ >$(PREFIX).content-x2.find
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /usr/share/secureboot >$(PREFIX).usr.share.secureboot.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-5.patch

$(addprefix 6-initially-connected-then-app-refreshed,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: PREFIX=6-initially-connected-then-app-refreshed
$(addprefix 6-initially-connected-then-app-refreshed,.before.current.fstab .desired.fstab .current.fstab .mountinfo) &: test-snapd-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-layout:content test-snapd-content:content
	snap run test-snapd-layout.sh -c true
	# This file is used by unit tests model the changes needed after the refresh below.
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).before.current.fstab
	sudo snap install --dangerous $(word 1,$^) # Refresh the app.
	cp /var/lib/snapd/mount/snap.test-snapd-layout.fstab $(PREFIX).desired.fstab
	cp /run/snapd/ns/snap.test-snapd-layout.fstab $(PREFIX).current.fstab
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt cat /proc/self/mountinfo >$(PREFIX).mountinfo
	sudo nsenter -m/run/snapd/ns/test-snapd-layout.mnt find /usr/share/secureboot >$(PREFIX).usr.share.secureboot.find
	sudo snap remove --purge test-snapd-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-6.patch

test-snapd-layout_a_all.snap: test-snapd-layout
	snap pack $<

test-snapd-content_a_all.snap: test-snapd-content-a
	snap pack $<

test-snapd-content_b_all.snap: test-snapd-content-b
	snap pack $<

=== vendor/github.com/gvalkov/golang-evdev/Makefile ===
all: ecodes.go

HEADERS  = /usr/include/linux/input.h
HEADERS += /usr/include/linux/input-event-codes.h

ecodes.go: ecodes.go.template
	./bin/genecodes.py $(HEADERS) $< > $@

.PHONY: ecodes.go

=== vendor/github.com/mvo5/libseccomp-golang/Makefile ===
# libseccomp-golang

.PHONY: all check check-build check-syntax fix-syntax vet test lint

all: check-build

check: vet test

check-build:
	go build

check-syntax:
	gofmt -d .

fix-syntax:
	gofmt -w .

vet:
	go vet -v

test:
	go test -v

lint:
	@$(if $(shell which golint),true,$(error "install golint and include it in your PATH"))
	golint -set_exit_status

=== core-initrd/24.04/debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DH_VERBOSE=1
export DH_OPTIONS

BUILDFLAGS:=
# disable DWARF generation in go linker
BUILDFLAGS+=-ldflags=-w
# Disable -buildmode=pie mode on all our 32bit platforms
# (i386 and armhf). For i386 because of LP: #1711052 and for
# armhf because of LP: #1822738
ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH_BITS),64)
BUILDFLAGS+=-buildmode=pie
endif

# check if we need to include the testkeys in the binary
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
# if enabled also enable bootloader assets testing and fault injection
_SNAP_TAGS:=nomanagers,withtestkeys,faultinject
else
_SNAP_TAGS:=nomanagers
endif

ifeq (${FIPSBUILD},1)
_SNAP_TAGS:=$(_SNAP_TAGS),goexperiment.opensslcrypto,snapdfips
endif

SNAP_TAGS=-tags "$(_SNAP_TAGS)"

######## targets start here

%:
	dh $@

override_dh_auto_build:
# very ugly test for FIPS variant of a toolchain
# see https://warthogs.atlassian.net/browse/FR-8860
ifeq (${FIPSBUILD},1)
	if ! test -f /usr/lib/go-1.21/src/crypto/internal/backend/openssl_linux.go; then \
		echo "Go 1.21 FIPS toolchain not found"; \
		exit 1; \
	fi
endif
# dh-golang sets GO111MODULE=off if present, fix that
	GOCACHE=/tmp/cache GO111MODULE=on go build -mod=vendor $(BUILDFLAGS) $(SNAP_TAGS) ./cmd/snap-bootstrap

override_dh_auto_install:
	rm -rf debian/tmp
	mkdir debian/tmp
	cp -ar factory/* debian/tmp

# splash functionality
	mkdir -p debian/tmp/usr/share/plymouth/themes/
	cp -a plymouth-theme-ubuntu-core/ubuntu-core \
		debian/tmp/usr/share/plymouth/themes/
	mkdir -p debian/tmp/usr/share/fonts/
	cp /usr/share/fonts/truetype/ubuntu/Ubuntu-R.ttf \
		debian/tmp/usr/share/fonts/Plymouth.ttf

	touch debian/tmp/etc/machine-id

override_dh_clean:
	dh_clean
	rm -f snap-bootstrap

# to avoid dh-golang breaking the build
override_dh_auto_test:

# disable dh_dwz (breaks build for go 1.22)
override_dh_dwz:

override_dh_python3:
	dh_python3 --no-ext-rename

override_dh_fixperms:
	dh_fixperms -Xusr/lib/ubuntu-core-initramfs/main

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/ubuntu-core-initramfs/main

override_dh_shlibdeps:
	dh_shlibdeps -Xusr/lib/ubuntu-core-initramfs/main

## snapd 2.71.1%2Bubuntu25.10.1

=== vendor/github.com/canonical/go-password-validator/Makefile ===
test:
	go test ./...

fmt:
	go fmt ./...

vet:
	go vet ./...

install-lint:
	GO111MODULE=off go get -u golang.org/x/lint/golint
	GO111MODULE=off go list -f {{.Target}} golang.org/x/lint/golint

lint:
	go list ./... | grep -v /vendor/ | xargs -L1 golint -set_exit_status

install-staticcheck:
	GO111MODULE=off go get honnef.co/go/tools/cmd/staticcheck

staticcheck:
	staticcheck -f stylish ./...

## snapd 2.71.1+ubuntu25.10.1

=== core-initrd/24.10/debian/changelog ===
ubuntu-core-initramfs (70+2.70+g138.873912a+24.10) oracular; urgency=medium

  * Update to snapd version 2.70+g138.873912a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 03 Jul 2025 21:50:02 -0400

ubuntu-core-initramfs (70+2.70+g50.d4bfa73+24.10) oracular; urgency=medium

  * Update to snapd version 2.70+g50.d4bfa73

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 12 Jun 2025 10:17:03 -0400

ubuntu-core-initramfs (70+2.69+g139.0b18e2d+24.10) oracular; urgency=medium

  * Update to snapd version 2.69+g139.0b18e2d

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 21 May 2025 15:32:00 -0400

ubuntu-core-initramfs (70+2.69+g104.4871148+24.10) oracular; urgency=medium

  * Update to snapd version 2.69+g104.4871148

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 30 Apr 2025 13:13:39 -0400

ubuntu-core-initramfs (70+2.68.2+g116.194fb1d+24.10) oracular; urgency=medium

  * Update to snapd version 2.68.2+g116.194fb1d

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 07 Mar 2025 17:02:21 -0500

ubuntu-core-initramfs (70+2.68.2+24.10) oracular; urgency=medium

  * Update to snapd version 2.68.2

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Mon, 03 Mar 2025 09:38:27 -0500

=== core-initrd/24.04/debian/control ===
Source: ubuntu-core-initramfs
Section: utils
Priority: optional
Maintainer: Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>
Build-Depends: debhelper-compat (= 13), dh-python,
               cpio,
               fakeroot,
               fonts-ubuntu,
               libblkid-dev,
               golang-go (>=2:1.18~) [!powerpc] | golang-1.18 [!powerpc] | golang-1.21,
               pkgconf
Standards-Version: 4.4.1
Homepage: https://launchpad.net/ubuntu-core-initramfs

Package: ubuntu-core-initramfs
Architecture: amd64 arm64 armhf riscv64
Depends: ${python3:Depends}, ${misc:Depends}, dracut-core (>= 051-1),
         python3:any,
         dracut-core,
         busybox-initramfs,
         zstd,
         sbsigntool,
         linux-firmware,
         kcapi-tools (>= 1.4.0-1ubuntu3),
         dbus,
         dmsetup,
         dosfstools,
         dpkg-dev,
         e2fsprogs,
         fakeroot,
         fdisk,
         git,
         kmod,
         libblkid1,
         libgcc-s1,
         mount,
         plymouth-label-ft,
         plymouth-theme-spinner,
         squashfs-tools,
         systemd,
         systemd-boot-efi,
         systemd-ukify,
         systemd-bootchart,
         cryptsetup-bin,
         systemd-sysv,
         tar,
         udev,
         util-linux,
         amd64-microcode [amd64],
         intel-microcode [amd64],
         optee-client-dev [arm64 armhf]
Description: standard embedded initrd
 Standard embedded initrd implementation to be used with Ubuntu Core
 systems. Currently targeting creating BLS Type2 like binaries.
